/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.YYLogger
 *  fire.log.beans.OpSilShopBean
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.item.ItemShuXing
 *  fire.pb.item.Module
 *  fire.pb.item.Pack
 *  fire.pb.npc.NpcManager
 *  fire.pb.pet.PetAttr
 *  fire.pb.pet.PetManager
 *  fire.pb.shop.SNpcSale
 *  fire.pb.shop.srv.floating.FileterFloatingShop
 *  fire.pb.shop.srv.floating.FloatingOneManager
 *  fire.pb.shop.srv.limit.LimitManager
 *  fire.pb.shop.utils.ShopParameters
 */
package fire.pb.shop.srv;

import fire.log.YYLogger;
import fire.log.beans.OpSilShopBean;
import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.item.ItemShuXing;
import fire.pb.item.Module;
import fire.pb.item.Pack;
import fire.pb.npc.NpcManager;
import fire.pb.pet.PetAttr;
import fire.pb.pet.PetManager;
import fire.pb.shop.SNpcSale;
import fire.pb.shop.srv.Shop;
import fire.pb.shop.srv.floating.FileterFloatingShop;
import fire.pb.shop.srv.floating.FloatingOneManager;
import fire.pb.shop.srv.limit.LimitManager;
import fire.pb.shop.utils.ShopParameters;
import java.util.ArrayList;

public class SaleShopBase
extends Shop {
    private final int shopId;
    protected Pack bag;
    protected int price;
    protected int moneytype;

    public SaleShopBase(ShopParameters params) {
        super(params.role, params.goods, params.num);
        this.shopId = params.shopId;
        this.getBag();
        this.originalGold = this.bag.getGold();
        this.originalSilver = this.bag.getMoney();
    }

    protected final Pack getBag() {
        if (this.bag == null) {
            this.bag = new Pack(this.role.getRoleId(), false);
        }
        return this.bag;
    }

    protected void commonSuccess() {
        if (this.goods.limitType != 0) {
            LimitManager.getInstance().saveSaleLimit(this.role.getRoleId(), this.goods, this.num);
        }
        if (FileterFloatingShop.getInstance().isFloatingOne((long)this.shopId)) {
            FloatingOneManager.getInstance().saleGoodsRecord((long)this.shopId, this.goods.getId(), (long)this.num);
        }
        this.writeYYLogger(OpSilShopBean.Op_SilShopBean_Sell);
    }

    private void writeYYLogger(int opId) {
        int curPrice = -1;
        float discount = 1.0f;
        ArrayList prices = this.goods.getPrices();
        ArrayList oldPrices = this.goods.getOldprices();
        if (prices != null && prices.size() != 0) {
            curPrice = (Integer)prices.get(0);
            if (oldPrices != null && oldPrices.size() != 0) {
                discount = (float)curPrice / (float)((Integer)this.goods.getOldprices().get(0)).intValue();
            }
        }
        OpSilShopBean opSilShopBean = new OpSilShopBean(opId, this.goods.itemId, this.goods.type, this.getQuality(this.goods.type, this.goods.itemId), this.num, 1, this.price * this.num, curPrice, discount, this.price, 0, 1, -1);
        YYLogger.silShopLog((long)this.role.getRoleId(), (OpSilShopBean)opSilShopBean);
    }

    private int getQuality(int itemType, int goodId) {
        int quailty = -1;
        if (itemType == 2) {
            PetAttr attr = PetManager.getInstance().getAttr(goodId);
            if (attr != null) {
                quailty = attr.getQuality();
            }
        } else {
            ItemShuXing attr = Module.getInstance().getItemManager().getAttr(goodId);
            if (attr != null) {
                quailty = attr.getNquality();
            }
        }
        return quailty;
    }

    protected boolean commonAddMoney(long money) {
        long ret = 0L;
        switch (this.moneytype) {
            case 1: {
                ret = this.bag.addSysMoney(money, "出售物品增加银币", YYLoggerTuJingEnum.tujing_Value_ShangChengCS, 0);
                break;
            }
            case 2: {
                ret = this.bag.addSysGold(money, "出售物品增加金币", YYLoggerTuJingEnum.tujing_Value_ShangChengCS, 0);
                break;
            }
            default: {
                return false;
            }
        }
        return ret != 0L;
    }

    protected boolean commonVerify() {
        SNpcSale ns = NpcManager.getInstance().getNpcSale(this.shopId);
        if (!ns.getGoodsids().contains(this.goods.getId())) {
            if (LOG.isDebugEnabled()) {
                LOG.info((Object)("没有该物品的出售" + this.goods.getId()));
            }
            return false;
        }
        if (!LimitManager.getInstance().isSaleLimit(this.role.getRoleId(), this.goods, this.num)) {
            if (LOG.isDebugEnabled()) {
                LOG.info((Object)("购买商品已达到限购次数" + this.goods.getId()));
            }
            return false;
        }
        ArrayList currencys = this.goods.getCurrencys();
        ArrayList prices = this.goods.getPrices();
        if (this.goods.getCurrencys() == null || this.goods.getPrices() == null) {
            if (LOG.isDebugEnabled()) {
                LOG.error((Object)("策划配置出错未填写货币类型:" + this.goods.getId()));
            }
            return false;
        }
        if (this.goods.getCurrencys().size() == 0 || this.goods.getPrices().size() == 0) {
            if (LOG.isDebugEnabled()) {
                LOG.error((Object)("策划配置出错未填写价格:" + this.goods.getId()));
            }
            return false;
        }
        this.moneytype = (Integer)currencys.get(0);
        this.price = (Integer)prices.get(0);
        int floatingPrice = FloatingOneManager.getInstance().getCurrPrice((long)this.shopId, this.goods.id);
        if (floatingPrice != -1) {
            this.price = floatingPrice;
        }
        return true;
    }
}

